/*
*	This was written by Arun Sagar and is placed into the public domain.
*	The author hereby disclaims copyright to this source code.
*
*	Pay it forward. 
*/



class cRPlayer
{
private:
	class cThinkTask : public cThreadTask
	{
	typedef cThreadTask super;

	private:
		const class cRPlayer *mommy;
		const cReversiBoard *pBoard;
		cReversiBoard::Position *px,*py;
		cTask *pTrigger;
		long maxdepth;

	public:
		cThinkTask(const class cRPlayer *pp = 0, const cReversiBoard *prgb=0, long dep = 0, cReversiBoard::Position *px = 0, cReversiBoard::Position *py = 0, cTask *pt = 0)
		{
			this->mommy = pp;
			this->pBoard = prgb;
			this->px = px;
			this->py = py;
			this->pTrigger = pt;
			this->maxdepth = dep;
		}
		virtual void Perform(void);
	};

public:
	typedef enum
	{
		None,
		Human,
		Computer,
		Network
	} Kind;

	typedef enum
	{
		Airhead,
		Loser,
		Greedy,
		Positional,
		Mobility
	} Brain;

private:
	cThinkTask *ptThinker;
	long maxdepth;
	long endgameThreshold;
	Kind kind;
	Brain brain;

public:
	cReversiBoard::Piece piece;
	char szName[256];
	
private:

public:
	cRPlayer(Kind k=None, cReversiBoard::Piece p=cReversiBoard::kPieceNone, Brain b = Airhead, long maxd = 3, long endt=0)
	{
		piece = p;
		kind = k;
		szName[0] = '\0';
		ptThinker=0;
		maxdepth = maxd;
		endgameThreshold = endt;
		brain = b;
		this->SetKind(k);
	}
	bool IsComputer(void) const {return this->kind == Computer;}

	void StopThinking(void);
	void StartThinking(const cReversiBoard*, cReversiBoard::Position*, cReversiBoard::Position*, cTask*);

	void Think(const cReversiBoard*, long, cReversiBoard::Position*, cReversiBoard::Position*, cTask* =0, const bool* =0) const;
	//void EndGame(const cReversiBoard*, cReversiBoard::Position*, cReversiBoard::Position*, cTask* =0, const bool* =0);

	void SetThinkingDepths(Brain b, long md, long et) {this->maxdepth = md; this->endgameThreshold = et; this->brain = b;}
	void GetThinkingDepths(Brain &b, long& md, long& et) {b = this->brain; md = this->maxdepth; et = this->endgameThreshold;}

	const char* GetName(void) const {return this->szName;}
	static void TestPlay(long, long);

	Kind GetKind(void) const {return this->kind;}
	void SetKind(Kind k) {this->kind = k; strcpy(this->szName, (Human==k)?"Human":"Computer");}
friend class cThinkTask;
};
